/* enemy.c */

#include <stdio.h>
#include <xsp2lib.h>

#include "main.h"
#include "player.h"
#include "enemy.h"

#define ENEMY_MAX	32	/* Gő吔 */

static ENEMY enemy[ENEMY_MAX];	/* [N */
static ENEMY *enemy_top,	/* gp̃[ÑXg */
 *enemy_null_top,		/* ̃[ÑXg */
 *enemy_end;			/* gp[ÑXg̖ */



/* Q[JnɌĂ΂ */
void EnemyInit (void)
{
	int i;

    /* XgȂ */
	enemy_top = NULL;
	enemy_end = NULL;
	enemy_null_top = enemy;
	for (i = 0; i < ENEMY_MAX; i++)
		enemy[i].next = &enemy[i + 1];

	enemy[ENEMY_MAX - 1].next = NULL;
}



/* GoɌĂ΂ */
void EnemyAlloc (short type, signed short x, signed short y)
{
	ENEMY *p;

	if (enemy_null_top == NULL)
		return;	/* 󂫂̃[NȂiLN^[I[o[j */

    /* Xg̖ɐVm[hǉiƂ͈Ⴄ̂ŒӁj */
	p = enemy_null_top;
	enemy_null_top = p->next;
	if (enemy_top == NULL)
		enemy_top = p;
	else
		enemy_end->next = p;
	p->next = NULL;
	enemy_end = p;

	p->type = type;
	p->lx = x << 16;
	p->ly = y << 16;

	p->pt = obj_zako02;
	p->info = 0x0700 | PRIORITY_ZAKO;	/* l߂ē̂͂悭Ȃ */

	return;
}



/* ƂɌĂ΂ */
void EnemyMove (void)
{
	ENEMY *p, *q;

	p = enemy_top;		/* ݒڂĂ郏[N */
	q = NULL;		/* PÕ[Ni[N폜ɕKvj */
	while (p != NULL) {
		/* GL̈ړ[` */

		/* wW@ɋ߂Â */
		if (p->lx > player->lx)
			p->lx -= 32768;
		else
			p->lx += 32768;

		p->ly += 2*65536;

	    /* ʃ[hiŒ萮jo */
		p->x = p->lx >> 16;
		p->y = p->ly >> 16;

		if (p->y > 256+32) {	/* xW 256+32 ȏȂ */
			if (q == NULL) {	/* Xg̈ԍŏ폜 */
				enemy_top = p->next;
				p->next = enemy_null_top;
				enemy_null_top = p;
				q = NULL;
				p = enemy_top;
			} else {
				if (p == enemy_end) {	/* Xg̈ԍŌ폜 */
					q->next = NULL;
					enemy_end = q;
					p->next = enemy_null_top;
					enemy_null_top = p;
					p = q->next;
				} else {
					q->next = p->next;
					p->next = enemy_null_top;
					enemy_null_top = p;
					p = q->next;
				}
			}
		} else {
			xobj_set_st (p);	/* \ */
			q = p;
			p = p->next;
		}
	}

}
